/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


/*=========================================================================
  Program:   bbtk
  Module:    $RCSfile: bbtkBlackBox.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 14:43:33 $
  Version:   $Revision: 1.25 $
=========================================================================*/





/**
 *  \file 
 *  \brief Class bbtk::BlackBox : abstract black-box interface. 
 */

/**
 * \class bbtk::WxGUIEditorGraphicBBS
 * \brief 
 */
 
#ifndef __WxGUIEditorGraphicBBS_h__
#define __WxGUIEditorGraphicBBS_h__

#include <wx/frame.h>
#include <wx/aui/aui.h>


namespace bbtk
{

	class wxGUIEditorGraphicContainer;
  
	class  wxGUIEditorGraphicBBS : public wxFrame
  {
  public: 
	  wxGUIEditorGraphicBBS(wxFrame *parent );
	  ~wxGUIEditorGraphicBBS();
  private:
	  wxAuiManager					m_mgr;
	  wxGUIEditorGraphicContainer	*editorgraphiccontainer;
	  
  protected:
	  
 };


}
// namespace bbtk
#endif

